/*
    epple2
    Copyright (C) 2008 by Christopher A. Mosher <cmosher01@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY, without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CONFIGEP2_H
#define CONFIGEP2_H



#include <wx/string.h>
#include <filesystem>
#include <string>

class Memory;
class MemoryRandomAccess;
class Slots;
class ScreenImage;
class CassetteIn;
class CassetteOut;
class Apple2;



class E2Config {
private:
    const std::filesystem::path file_path;
    const bool prefs_only;

    std::ifstream *openFile();
    std::ifstream *openFilePref(const wxString& s_name);
    std::ifstream *openFileExternal(const std::filesystem::path& path);
    std::ifstream *openFileLegacy();

public:
    E2Config(const std::filesystem::path& f, bool p);
    ~E2Config();

    void parse(MemoryRandomAccess& ram, Memory& rom, Slots& slts, int& revision, ScreenImage& gui, CassetteIn& cassetteIn, CassetteOut& cassetteOut, Apple2* apple2);
};



#endif
